/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - convert.c - source file for recalculate functions, for 10 from/to 256
    based numbers.

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#ifndef __GTK_H__
 typedef unsigned int guint;
 typedef int gint;
 typedef char gchar;
#endif
#include <stdlib.h>

guint sqrn(guint num, gint level)
{/* calculate n square of number */
 if(level>2) return(num*sqrn(num,level-1));/* go recursive */
 else if(level==2) return(num*num);/* standard square */
  else if(level==1) return(num);/* by 1 is number itself */
   else return(1);/* by 0 is 1 */
}/* end sqrn */

void doto4(gchar *inpstr)
{/* convert to 4 bit entry */
gint i,ign1=0,ign2=0,rw1=0,rw2=0;

for(i=0;i<=15;i++){/* go thru entry */
 switch(inpstr[i]){/* check action */
	case '1':/* set write */
		if(i<8) rw1|=sqrn(2,i);else rw2|=sqrn(2,i-8);break;
	case '0':break;/* skip 0 */
	default:/* set by default */
	        if(i<8) ign1|=sqrn(2,i);else ign2|=sqrn(2,i-8);break;
 }/* end switch */
}/* end for i */
inpstr[0]=rw1;inpstr[1]=ign1;inpstr[2]=rw2;inpstr[3]=ign2;/* return value */
}/* end doto4() */

void dofrom4(gchar *inpstr)
{/* convert from 4 bit entry to string */
gint ign1=0,ign2=0,rw1=0,rw2=0;

rw1=inpstr[0];ign1=inpstr[1];rw2=inpstr[2];ign2=inpstr[3];/* get value */
if(ign1&1) inpstr[0]='='; else if(rw1&1) inpstr[0]='1'; else inpstr[0]='0';
if(ign1&2) inpstr[1]='='; else if(rw1&2) inpstr[1]='1'; else inpstr[1]='0';
if(ign1&4) inpstr[2]='='; else if(rw1&4) inpstr[2]='1'; else inpstr[2]='0';
if(ign1&8) inpstr[3]='='; else if(rw1&8) inpstr[3]='1'; else inpstr[3]='0';
if(ign1&16) inpstr[4]='='; else if(rw1&16) inpstr[4]='1'; else inpstr[4]='0';
if(ign1&32) inpstr[5]='='; else if(rw1&32) inpstr[5]='1'; else inpstr[5]='0';
if(ign1&64) inpstr[6]='='; else if(rw1&64) inpstr[6]='1'; else inpstr[6]='0';
if(ign1&128) inpstr[7]='='; else if(rw1&128) inpstr[7]='1'; else inpstr[7]='0';
if(ign2&1) inpstr[8]='='; else if(rw2&1) inpstr[8]='1'; else inpstr[8]='0';
if(ign2&2) inpstr[9]='='; else if(rw2&2) inpstr[9]='1'; else inpstr[9]='0';
if(ign2&4) inpstr[10]='='; else if(rw2&4) inpstr[10]='1'; else inpstr[10]='0';
if(ign2&8) inpstr[11]='='; else if(rw2&8) inpstr[11]='1'; else inpstr[11]='0';
if(ign2&16) inpstr[12]='='; else if(rw2&16) inpstr[12]='1'; else inpstr[12]='0';
if(ign2&32) inpstr[13]='='; else if(rw2&32) inpstr[13]='1'; else inpstr[13]='0';
if(ign2&64) inpstr[14]='='; else if(rw2&64) inpstr[14]='1'; else inpstr[14]='0';
if(ign2&128) inpstr[15]='='; else if(rw2&128) inpstr[15]='1';
else inpstr[15]='0'; inpstr[16]=0;/* make string */
}/* end doto4() */
