/*****************************************************************************
 *  dump.c: here are functions for dumping and checking ICs
 *  This is part of IC-tester program.
 *  Copyright (C) 2001,2002  Silvio Klaic, sklaic@student.math.hr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *****************************************************************************/

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include "portlib.h"
#include "device.h"
#include "find.h"

void dump_ic(unsigned int IO)
{
char ch[81],fsname[128],email[128],descr[128],fname[256];
int pins,Ppin,Gpin,i,j,k,lastpr;
FILE *f;

if (allow_io(IO, 2) == -1) {/* test port access */
 fprintf(stderr,"Opa... You aren't being allowed access to the ports 0x%03X\
 and 0x%03X.\n",IO,IO+1);
}else{/* ok access granted continue */
 if(is_power_on(IO)) printf("\n => WARNING: ictester device not powered - can not do dump !\n\n");
 else{/* all ok do dump */
  printf("Selected port is: 0x%03X, please fill out next questions:\n",IO);
  enable_port(1,IO);lastpr=-1;ch[0]=0;/* enable ictester device */
  while((ch[0]!='y')&&(ch[0]!='Y')){/* get info on IC */
   printf("Type how many pins have IC for test (default 16):");fgets(ch,4,stdin);
   pins=0;pins=atoi(ch);if( (pins<1)||(pins>16) ) pins=16;/* number of pins */
   printf("Type on which pin is Vcc (+5V) (default %d):",pins);
   fgets(ch,4,stdin);i=div(pins,2).quot;/* get half number */
   Ppin=0;Ppin=atoi(ch);if( (Ppin<1)||(Ppin>pins) ) Ppin=pins;/* power pin */
   printf("Type on which pin is GND (default %d):",i);fgets(ch,4,stdin);
   Gpin=0;Gpin=atoi(ch);if( (Gpin<1)||(Gpin>pins) ) Gpin=i;/* GND pin */
   printf("Program will dump IC with %d pins, +5V is on pin %d and GND at %d.\n\
Is this correct? (y/N):",pins,Ppin,Gpin);fgets(ch,20,stdin);
  }/* end while */
  ch[0]=0;while((ch[0]!='y')&&(ch[0]!='Y')){/* get info on who doing this */
   printf("Type your first and second name:");fgets(fsname,128,stdin);
   fsname[strlen(fsname)-1]=0;if(fsname[0]==0) sprintf(fsname,"anonymous person");
   printf("Type your e-mail (optional):");fgets(email,128,stdin);
   email[strlen(email)-1]=0;if(email[0]==0) sprintf(email,"not given");
   printf("Type information of this ic, max 128 characters (root number, etc):"
		   );fgets(descr,128,stdin);
   descr[strlen(descr)-1]=0;if(descr[0]==0) sprintf(descr,"unknown");
   printf("This dump is make by %s, e-mail address is %s.\n\
IC info: %s.\nIs information above correct? (y/N):",fsname,email,descr);
   fgets(ch,20,stdin);
  }/* end while */
  ch[0]=1;while(ch[0]!=0){/* get info on ic */
   printf("Type file name where to store dump (default new.ddf)\n:");
   fgets(fname,256,stdin);fname[strlen(fname)-1]=0;if(fname[0]==0)
    sprintf(fname,"new.ddf");/* default file name */
   if((f=fopen(fname,"w"))==NULL){/* check if is possible write to data file */
    printf("Can't write in data file %s:\n%s !\n",fname,strerror(errno));
   }else{ fclose(f);ch[0]=0;}
  }/* end while */
  f=fopen(fname,"w");/* open file */
  fprintf(f,"Dumped IC Tester file\n%s\n%4d%4d%4d\n",descr,pins,Ppin,Gpin);
  fprintf(f,"%s\n%s\n",fsname,email);/* write rest of data */
  i=div(pins,2).quot;if(Ppin>i) Ppin+=16-pins;if(Gpin>i) Gpin+=16-pins;
  		/* set for test socket */
  switch(div(pins,2).quot){
   case 1: pins=1;break;
   case 2: pins=3;break;
   case 3: pins=7;break;
   case 4: pins=15;break;
   case 5: pins=31;break;
   case 6: pins=63;break;
   case 7: pins=127;break;
   default: pins=255;break;
  }/* end switch */	   
/* yeah I know, if you want optimize this go for it, I don't have time */
  for(i=pins;i>=0;i--){/* create first 8 pins */
   for(j=pins;j>=0;j--){/* create last 8 pins */
    for(k=0;k<=15;k++) ch[k]='=';/* fill with = */
    if(i & 1) ch[0]='1'; if(i & 2) ch[1]='1'; if(i & 4) ch[2]='1';
    if(i & 8) ch[3]='1'; if(i & 16) ch[4]='1'; if(i & 32) ch[5]='1';
    if(i & 64) ch[6]='1'; if(i & 128) ch[7]='1';/* set first 8 pins */
    if(j & 1) ch[15]='1'; if(j & 2) ch[14]='1'; if(j & 4) ch[13]='1';
    if(j & 8) ch[12]='1'; if(j & 16) ch[11]='1'; if(j & 32) ch[10]='1';
    if(j & 64) ch[9]='1'; if(j & 128) ch[8]='1';/* set last 8 pins */
    ch[Ppin-1]='1';ch[Gpin-1]='0';/* set pre defined power */
    if(!portwrite(IO,ch)){/* all ok do read and save to file */
     ch[16]=0;fprintf(f,"%s",ch);/* update set information */
     portread(IO,ch);ch[16]=0;fprintf(f,"%s\n",ch);/* read data and update */
    }else/* end if, all other is ignored possible device not working stable */
     printf("\rError! Data aren't successful write to device.\n\
There is problem with transfering data to device, possible low power?\n");
   }/* end for j */
   if(lastpr!=(50-div(i*50,pins).quot)){/* ok there is changes, update */
   sprintf(ch,"\rDumping: |%s", "====================================================");ch[37-div(26*i,pins).quot]=0;lastpr=50-div(i*50,pins).quot;
   printf("\r%-62s| %3d%%",ch,lastpr);fflush(NULL);}/* progress bar */
  }/* end for i */
  for(i=pins;i>=0;i--){/* create first 8 pins */
   for(j=pins;j>=0;j--){/* create last 8 pins */
    for(k=0;k<=15;k++) ch[k]='=';/* fill with = */
    if(i & 1) ch[0]='0'; if(i & 2) ch[1]='0'; if(i & 4) ch[2]='0';
    if(i & 8) ch[3]='0'; if(i & 16) ch[4]='0'; if(i & 32) ch[5]='0';
    if(i & 64) ch[6]='0'; if(i & 128) ch[7]='0';/* set first 8 pins */
    if(j & 1) ch[15]='0'; if(j & 2) ch[14]='0'; if(j & 4) ch[13]='0';
    if(j & 8) ch[12]='0'; if(j & 16) ch[11]='0'; if(j & 32) ch[10]='0';
    if(j & 64) ch[9]='0'; if(j & 128) ch[8]='0';/* set last 8 pins */
    ch[Ppin-1]='1';ch[Gpin-1]='0';/* set pre defined power */
    if(!portwrite(IO,ch)){/* all ok do read and save to file */
     ch[16]=0;fprintf(f,"%s",ch);/* update set information */
     portread(IO,ch);ch[16]=0;fprintf(f,"%s\n",ch);/* read data and update */
    }else/* end if, all other is ignored possible device not working stable */
     printf("\rError! Data aren't successful write to device.\n\
There is problem with transferring data to device, possible low power?\n");
   }/* end for j */
   if(lastpr!=(100-div(i*50,pins).quot)){/* ok there is changes, update */
   sprintf(ch,"\rDumping: |%s", "====================================================");ch[62-div(25*i,pins).quot]=0;lastpr=100-div(i*50,pins).quot;
   printf("\r%-62s| %3d%%",ch,lastpr);fflush(NULL);}/* progress bar */
  }/* end for i */
  printf("\r%79s\rDumping into %s complete.\n"," ",fname);
  fflush(f);fclose(f);/* close file */
  enable_port(0,IO);/* reset and disable ictester device */
 }/* end else if powered */
 if (disallow_io(IO, 2) == -1)/* close port */
  fprintf(stderr, "Woha! Can't disengage port.\n\
You could have some problems with this port from now on...\n");
}/* end else if port access */
}/* end dump_ic() */

short int check_ic(unsigned int IO,char *Fname)
{
char tmp[20],ch[128];
int pins,Ppin,Gpin,i,lastpr;
unsigned long end_file,pos_file;
short int testing=0;
FILE *f;

if((f=find_A_file(Fname,".ddf"))==NULL){/* file not opened */
 printf("Can't read from data file %s:\n%s !\n",Fname,strerror(errno));
}else{/* all ok continue */
 if (allow_io(IO, 2) == -1) {/* test port access */
  fprintf(stderr,"Opa... You aren't being allowed access to the ports 0x%03X\
 and 0x%03X.\n",IO,IO+1);
 }else{/* ok access granted continue */
  if(is_power_on(IO)) printf("\n => WARNING: ictester device not powered - can not do check !\n\n");
  else{/* all ok do check */
   enable_port(1,IO);lastpr=-1;/* enable ictester device */
   fseek(f,0L,SEEK_END);end_file=ftell(f);rewind(f);/* get file size */
   fgets(ch,80,f);ch[strlen(ch)-1]=0;/* get first line */
   if(strcmp(ch,"Dumped IC Tester file")==0){/* yeah this is it... */
    printf("Selected port is: 0x%03X. Information from data file (%ld bytes):\n",IO,end_file);
    fgets(ch,128,f);printf("IC information: %s",ch);/* get description */
    fgets(ch,5,f);pins=atoi(ch);fgets(ch,5,f);Ppin=atoi(ch);fgets(ch,8,f);Gpin=atoi(ch);/* get number of pins, power pin and GND pin */
    printf("Number of pins: %d, power at pin %d, GND at pin %d.\n",pins,Ppin,Gpin);/* write information rest of information */
    fgets(ch,128,f);printf("Created by: %s",ch);/* display author */
    fgets(ch,128,f);printf("Author E-mail address: %s",ch);/* e-mail address */
    printf("Do you want continue to check your test IC? (y/N):");fgets(ch,4,stdin);
    if( (ch[0]=='y')||(ch[0]=='Y') ){/* ok do check */
     testing=1;/* set check variable to true */
     do{/* go to the end of file */
      ch[0]=0;fgets(ch,17,f);fgets(tmp,20,f);/* get write data and read data */
      for(i=0;i<=15;i++) if(ch[i]!='=') tmp[i]='=';/* check only at NC */
      if(ch[0]!=0){/* bug fix for double data at end of file */
      if(!portwrite(IO,ch)){/* all ok do read and compare */
       portread(IO,ch);ch[16]=0;tmp[16]=0;/* read data */
       for(i=0;i<=15;i++) if( (tmp[i]!='=')&&(ch[i]!=tmp[i]) ) testing=0;
       /* oho, not match... */
      }else{ /* all other is ignored possible device not working stable */
       printf("\rError! Data aren't successful write to device.\n\
There is problem with transferring data to device, possible low power?\n");
       testing=0;}/* uh, error when write..., end else if portwrite */
       pos_file=ftell(f);if(lastpr!=div(pos_file*100,end_file).quot){
        sprintf(ch,"\rChecking: |%s",/* ok progress changes, do update */
          "====================================================");
        ch[(short int)ldiv(51*pos_file,end_file).quot+12]=0;
        lastpr=div(pos_file*100,end_file).quot;printf("\r%-63s| %3d%%",ch,
          lastpr);fflush(NULL);}/* progress bar */
      }/* end bug fix */
     }while(!feof(f)&&testing);/* end go thru file */
     if(testing) printf("\r%79s\rTesting complete, testing IC match 100%% with\
 data from file.\n"," ");
     else printf("\r%79s\rTesting fail!, tested IC not match with data from\
 file.\n"," ");
    }/* end if ch==y */
   }else if(strcmp(ch,"Dumped IC Tester link")==0){/* yeah this is link... */
     ch[0]=0;fgets(ch,256,f);ch[strlen(ch)-1]=0;/* read information line */
     printf("%s\n",ch);ch[0]=0;fgets(ch,256,f);ch[strlen(ch)-1]=0;/* location */
     check_ic(IO,ch);testing=-1;/* do new scan with other file */
    }else{/* mh? this isn't IC Tester dump file, abort check! */
     printf("File %s isn't IC Tester dump file!\n",Fname);/* write error */
    }/* end else if strcmp */
   if(testing!=-1) enable_port(0,IO);/* reset and disable ictester device */
  }/* end else if powered */
  if (disallow_io(IO, 2) == -1)/* close port */
   fprintf(stderr, "Woha! Can't disengage port.\n\
You culd have some problems with this port from now on...\n");
 }/* end else if port access */
 fclose(f);/* close file */
}/* end else if fopen */
return(testing);
}/* end check_ic() */

