/*****************************************************************************
 *  find.c: here are functions for finding analyze data files
 *  This is part of IC-tester program.
 *  Copyright (C) 2001,2002  Silvio Klaic, sklaic@student.math.hr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *****************************************************************************/

#ifdef __minix
#define _MINIX
#endif

#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <ctype.h>
#include <errno.h>

#ifdef DOS
/* here is inplement strcasecmp function, because BC45 don't have it */
short int strcasecmp(register char *s, register char *t)
{
while(tolower(*s)==tolower(*t)){/* go thru string */
 if(!*s) return(0); /* end reached, strings identical */
 s++;t++;/* go to next character */
}/* end while */
return(tolower(*s)-tolower(*t));/* return difference between two strings */
}/* end strcasecmp */
#endif

FILE *find_A_file(char *F_name, char *F_Ext)
{
char ch[256];
FILE *f;

strcpy(ch,F_name);/* copy location of file */
f=fopen(ch,"r");/* try to open file */
if(f==NULL){/* can't read file? try under another name */
 strcat(ch,F_Ext);/* add suffix */
 f=fopen(ch,"r");/* try to open file */
}/* end if can't open */
if(f==NULL){/* can't read file? try under another name */
 sprintf(ch,"%s/%s",DATADIR,F_name);/* check in data dir */
 f=fopen(ch,"r");/* try to open file */
}/* end if can't open */
if(f==NULL){/* can't read file? try under another name */
 strcat(ch,F_Ext);/* add suffix */
 f=fopen(ch,"r");/* try to open file */
}/* end if can't open */
if(f==NULL){/* can't read file? try under another name */
 sprintf(ch,"%s/%s",DATATMP,F_name);/* check in datatmp dir */
 f=fopen(ch,"r");/* try to open file */
}/* end if can't open */
if(f==NULL){/* can't read file? try under another name */
 strcat(ch,F_Ext);/* add suffix */
 f=fopen(ch,"r");/* try to open file */
}/* end if can't open */
return(f);
}/* end find_A_file() */

unsigned long int is_in_database(char *DatLoc,char *Fname)
{
char lin[128];
FILE *f;
unsigned long int pos=0;
int i;

if((f=fopen(DatLoc,"rb"))!=NULL){/* try to open file */
 if((fgetc(f)==255)&&(fgetc(f)==0)){/* it's ic-tester database, scan it */
  printf("Checking for \"%s\" in %s (v%d): ",Fname,DatLoc,fgetc(f));
  fflush(NULL);/* write status */
  i=fgetc(f);/* get size of string */
  while(!feof(f)&&(pos==0)){/* until you get to the end of file */
   pos=ftell(f)-1;fgets(lin,(i&127)+1,f);/* get position and name */
   if(strcasecmp(lin,Fname)!=0) pos=0;/* not found */
   if(i&128) fseek(f,(long)fgetc(f),SEEK_CUR);/* skip link data, if any */
   fseek(f,((long)fgetc(f)*256*256*256)+((long)fgetc(f)*256*256)+
	((long)fgetc(f)*256)+((long)fgetc(f)),SEEK_CUR);/* skip test data */
   i=fgetc(f);/* get size of next name */
  }/* end while */ 
  if(pos==0) printf("None!\n"); else printf("Found!\n");/* report */
 }/* end if ic-tester database */
 fclose(f);/* close database */
}/* end if opened */
return(pos);
}/* end is_in_database() */

unsigned long int find_D_file(char *Df_loc,char *F_name)
{
unsigned long int pos=0;
int i;
DIR *D;
struct dirent *ddata;

sprintf(Df_loc,"%s/default.tdf",DATADIR);/* check in data dir */
pos=is_in_database(Df_loc,F_name);/* check default database in data dir */
if(pos==0){/* entry don't exists, check it in data temp dir */
 sprintf(Df_loc,"%s/default.tdf",DATATMP);/* check in data temp dir */
 pos=is_in_database(Df_loc,F_name);/* check default database in data temp dir */
}/* end if not exists */
if(pos==0){/* entry don't exists, check it in data dir */
 if((D=opendir(DATADIR))!=NULL){/* check all bases in data dir */
  ddata=readdir(D);while((ddata!=NULL)&&(pos==0)){/* check all names in dir */
   i=0;while(ddata->d_name[i+4]!=0) i++;/* get extension */
   if((i>0)&&(ddata->d_name[i]=='.')&&(tolower(ddata->d_name[i+1])=='t')&&
	(tolower(ddata->d_name[i+2])=='d')&&(tolower(ddata->d_name[i+3])=='f')&&
	(strcmp("default.tdf",ddata->d_name)!=0)){/* found it, do check */
    sprintf(Df_loc,"%s/%s",DATADIR,ddata->d_name);/* make path */
    pos=is_in_database(Df_loc,F_name);}/* check database in data dir */
  ddata=readdir(D);}/* end while thru dir */
 closedir(D);}/* close directory */
 if(pos==0){/* entry don't exists, check it in data temp dir */
  if((D=opendir(DATATMP))!=NULL){/* check all bases in data temp dir */
   ddata=readdir(D);while((ddata!=NULL)&&(pos==0)){/* check all names in dir */
    i=0;while(ddata->d_name[i+4]!=0) i++;/* get extension */
    if((i>0)&&(ddata->d_name[i]=='.')&&(tolower(ddata->d_name[i+1])=='t')&&
	(tolower(ddata->d_name[i+2])=='d')&&(tolower(ddata->d_name[i+3])=='f')&&
	(strcmp("default.tdf",ddata->d_name)!=0)){/* found it, do check */
     sprintf(Df_loc,"%s/%s",DATATMP,ddata->d_name);/* make path */
     pos=is_in_database(Df_loc,F_name);}/* check database in data temp dir */
   ddata=readdir(D);}/* end while thru dir */
  closedir(D);}/* close directory */
 }/* end if not exists */
}/* end if not exists */
return(pos);
}/* end find_D_file() */

void write_data_from_database(FILE *f,char *D_loc)
{
char lin[256],ch[128];
FILE *d,*t;
int i;
long size;
short int found_it;

if((d=fopen(D_loc,"rb"))!=NULL){/* try to open database file */
 if((fgetc(d)==255)&&(fgetc(d)==0)){/* it's ic-tester database, scan it */
  fprintf(f,"List of test entries in database %s (v%d):<BR>\n\
<TABLE WIDTH=\"99%%\"><TR><TD><B>Test entry</B></TD><TD><B>Type of entry\
</B></TD><TD><B>IC true name</B></TD><TD><B>IC description</B></TD>\
<TD><B>Confirmed test?</B></TD></TR>\n",D_loc,fgetc(d));
  i=fgetc(d);/* get size of string */
  while(!feof(d)){/* until you get to the end of file */
   lin[0]=0;fgets(lin,(i&127)+1,d);/* get position and name */
   t=fopen("chk.tmp","rt");ch[0]=0;fgets(ch,128,t);found_it=0;strcat(lin,"\n");
   while(!feof(t)&&(found_it==0)){/* check entries in temp file */
    if(strcasecmp(ch,lin)==0) found_it=1;/* found match */
    ch[0]=0;fgets(ch,128,t);/* read next line */
   } fclose(t); /* end reading temp file */
   if(found_it==0){/* entry not duplicated, display it */
    t=fopen("chk.tmp","at");fprintf(t,"%s\n",lin);fclose(t);/* add tmp entry */
    fprintf(f,"<TR><TD>%s</TD>",lin);/* write test name */
    if(i&128){ i=fgetc(d);lin[0]=0;fgets(lin,i+1,d);fprintf(f,"<TD>link to %s\
</TD>",lin);
    }else fprintf(f,"<TD><B>test data</B></TD>");/* regular data file */
    size=fgetc(d)*256*256*256+fgetc(d)*256*256+fgetc(d)*256+fgetc(d)+ftell(d);
    i=fgetc(d);lin[0]=0;fgets(lin,i+1,d);fprintf(f,"<TD>%s</TD>",lin);/*name*/
    i=fgetc(d);lin[0]=0;fgets(lin,i+1,d);fprintf(f,"<TD>%s</TD>",lin);/*desc*/
    i=fgetc(d)*256+fgetc(d);lin[0]=0;if(i>3) fgets(lin,5,d);/* get status */
    lin[4]=0;if((lin[0]!=0)&&(strcasecmp(lin,"none")!=0))
     fprintf(f,"<TD>YES</TD></TR>\n");/* there are confirmed test */
    else fprintf(f,"<TD>NO</TD></TR>\n");/* test confirmed? */
    fseek(d,size,SEEK_SET);/* skip to next entry */
   }else{/* skipp this entry */
    if(i&128) fseek(d,(long)fgetc(d),SEEK_CUR);/* skip link location */
    size=fgetc(d)*256*256*256+fgetc(d)*256*256+fgetc(d)*256+fgetc(d)+ftell(d);
    fseek(d,size,SEEK_SET);/* skip to next entry */
   }/* end else if found_it */
   i=fgetc(d);/* get size of next name */
  }/* end while */ 
  fprintf(f,"</TABLE><BR>\n");/* end table */
 }/* end if ic-tester database */
 fclose(d);/* close database */
}/* end if opened */
}/* end write_data_from_database() */

void write_data_from_file(FILE *f,char *What_dir,char *f_name,int dot)
{
char lin[1024];
FILE *t;
short int found_it;

t=fopen("chk.tmp","rt");lin[0]=0;fgets(lin,128,t);found_it=0;f_name[dot]=0;
while(!feof(t)&&(found_it==0)){/* check entries in temp file */
 lin[dot]=0;/* make identical entry for compare */
 if(strcasecmp(lin,f_name)==0) found_it=1;/* found match */
 lin[0]=0;fgets(lin,128,t);/* read next line */
} fclose(t); /* end reading temp file */
if(found_it==0){/* entry not duplicated, display it */
 f_name[dot]='.';sprintf(lin,"%s/%s",What_dir,f_name);/* make path */
 t=fopen(lin,"rt");if(t!=NULL){/* all ok, get data from file */
  fgets(lin,255,t);fclose(t);/* get type of file and close it */
  if((strcmp(lin,"Analyze IC Tester data\n")==0)||
	(strcmp(lin,"Analyze IC Tester link\n")==0)){/* file ok */
   f_name[dot]=0;t=fopen("chk.tmp","at");fprintf(t,"%s\n",f_name);
   fclose(t);f_name[dot]='.';fprintf(f,"<TR><TD>%s</TD>",f_name);/* to tmp */
   sprintf(lin,"%s/%s",What_dir,f_name);/* make path */
   t=fopen(lin,"rt");found_it=0;/* open analayze file again and do read */
   lin[0]=0;fgets(lin,255,t);if(strcmp(lin,"Analyze IC Tester data\n")==0)
    fprintf(f,"<TD><B>test data</B></TD><TD>"); else{ fprintf(f,"<TD>link to");
    lin[0]=0;fgets(lin,255,t);lin[0]=0;fgets(lin,255,t);/* skip info line */
    fprintf(f,"%s</TD><TD>",lin);}/* end else if analyze file */
   while(!feof(t)){/* go thru file */
    if((lin[0]!=0)&&(lin[0]!='#')&&(lin[0]!=32)&&(lin[0]!='\n')&&(lin[1]==':')){
     switch (lin[0]){/* find type of information */ 
      case 'D': lin[0]=' ';lin[1]=' ';fprintf(f,"%s",lin);break;/* descr */
      case 'N': lin[0]=' ';lin[1]=' ';fprintf(f,", <B>%s</B> ",lin);break;
      case 'T': lin[7]=0; if(strcasecmp(lin,"T: none")!=0) found_it=1;break;
     }/* end switch */
    }/* end if data line */
    lin[0]=0;fgets(lin,255,t);/* read next line */
   }fclose(t);/* close file */
   if(found_it) fprintf(f,"</TD><TD>YES</TD></TR>\n"); else fprintf(f,"</TD>\
<TD>NO</TD></TR>\n");/* write confirme information */
  }/* end if type match */
 }/* can't read file, skipp it */
}/* end else if found_it */
}/* end write_data_from_file() */

void create_supported_file(void)
{
FILE *f;
DIR *D;
int i;
struct dirent *ddata;
char loc[1024];

if((f=fopen("chk.tmp","w+t"))!=NULL){/* all ok go to open html file */
 fclose(f);if((f=fopen("supported.html","wt"))!=NULL){/* ok, do scan */
  fprintf(f,"<HTML>\n<!-- This is generated by ictester program v%s -->\n\
<HEAD>\n<TITLE>Autogenerated IC Tester list of IC test files</TITLE>\n\
<META NAME=\"GENERATOR\" CONTENT=\"ictester program (version %s)\">\n\
</HEAD>\n<BODY TEXT=\"#443399\" BGCOLOR=\"#CFEBEF\">\n<H2><CENTER>List of \
currently supported ICs for full testing at IC Tester device</H2></CENTER>\n",
VER,VER);
  sprintf(loc,"%s/default.tdf",DATADIR);/* check default database in data dir */
  write_data_from_database(f,loc);/* write data from database */
  sprintf(loc,"%s/default.tdf",DATATMP);/* check default database in data dir */
  write_data_from_database(f,loc);/* write data from database */
  if((D=opendir(DATADIR))!=NULL){/* check all bases in data dir */
   ddata=readdir(D);while(ddata!=NULL){/* check all names in dir */
    i=0;while(ddata->d_name[i+4]!=0) i++;/* get extension */
    if((i>0)&&(ddata->d_name[i]=='.')&&(tolower(ddata->d_name[i+1])=='t')&&
	(tolower(ddata->d_name[i+2])=='d')&&(tolower(ddata->d_name[i+3])=='f')&&
	(strcmp("default.tdf",ddata->d_name)!=0)){/* found it, do check */
     sprintf(loc,"%s/%s",DATADIR,ddata->d_name);/* make path */
     write_data_from_database(f,loc);}/* check database in data dir */
   ddata=readdir(D);}/* end while thru dir */
  closedir(D);}/* close directory */
  if((D=opendir(DATATMP))!=NULL){/* check all bases in data temp dir */
   ddata=readdir(D);while(ddata!=NULL){/* check all names in dir */
    i=0;while(ddata->d_name[i+4]!=0) i++;/* get extension */
    if((i>0)&&(ddata->d_name[i]=='.')&&(tolower(ddata->d_name[i+1])=='t')&&
	(tolower(ddata->d_name[i+2])=='d')&&(tolower(ddata->d_name[i+3])=='f')&&
	(strcmp("default.tdf",ddata->d_name)!=0)){/* found it, do check */
     sprintf(loc,"%s/%s",DATATMP,ddata->d_name);/* make path */
     write_data_from_database(f,loc);}/* check database in data temp dir */
   ddata=readdir(D);}/* end while thru dir */
  closedir(D);}/* close directory */
  /* check all analayze tet files */
  if((D=opendir(DATADIR))!=NULL){/* check all bases in data dir */
   fprintf(f,"List of test analayze files in %s:<BR>\n\
<TABLE WIDTH=\"99%%\"><TR><TD><B>Test entry</B></TD><TD><B>Type of entry</B>\
</TD><TD><B>IC description, IC true name</B></TD><TD><B>Confirmed test?</B>\
</TD></TR>\n",DATADIR);
   ddata=readdir(D);while(ddata!=NULL){/* check all names in dir */
    i=0;while(ddata->d_name[i+4]!=0) i++;/* get extension */
    if((i>0)&&(ddata->d_name[i]=='.')&&(tolower(ddata->d_name[i+1])=='a')&&
	(tolower(ddata->d_name[i+2])=='d')&&(tolower(ddata->d_name[i+3])=='f'))
     write_data_from_file(f,DATADIR,ddata->d_name,i);/* check analyze file */
   ddata=readdir(D);}/* end while thru dir */
  closedir(D);fprintf(f,"</TABLE><BR>\n");}/* close directory */
  if((D=opendir(DATATMP))!=NULL){/* check all bases in data temp dir */
   fprintf(f,"List of test analayze files in %s:<BR>\n\
<TABLE WIDTH=\"99%%\"><TR><TD><B>Test entry</B></TD><TD><B>Type of entry</B>\
</TD><TD><B>IC description, IC true name</B></TD><TD><B>Confirmed test?</B>\
</TD></TR>\n",DATATMP);
   ddata=readdir(D);while(ddata!=NULL){/* check all names in dir */
    i=0;while(ddata->d_name[i+4]!=0) i++;/* get extension */
    if((i>0)&&(ddata->d_name[i]=='.')&&(tolower(ddata->d_name[i+1])=='a')&&
	(tolower(ddata->d_name[i+2])=='d')&&(tolower(ddata->d_name[i+3])=='f'))
     write_data_from_file(f,DATATMP,ddata->d_name,i);/* check analyze file */
   ddata=readdir(D);}/* end while thru dir */
  closedir(D);fprintf(f,"</TABLE><BR>\n");}/* close directory */
  fprintf(f,"</BODY>\n</HTML>\n");fclose(f);remove("chk.tmp");/* clean up */
 }else/* oho can't open output file */
  fprintf(stderr,"Can't create supported.html file: %s!\n",strerror(errno));
}else/* temp file not opened, can't perform scan */
 fprintf(stderr,"Can't create temporary file chk.tmp: %s!\n",strerror(errno));
}/* end create_supported_file()*/

