/*****************************************************************************
 *  test1of2.c: here are functions for testing ictester device
 *  -=> this file is broken in two parts, because minix cc compiler have
 *  -=> problems to compile entire file 
 *  This is part of IC-tester program.
 *  Copyright (C) 2001,2002  Silvio Klaic, sklaic@student.math.hr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *****************************************************************************/
#ifndef DOS
#include <unistd.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "test.h"
#include "portlib.h"
#include "device.h"

int test_port( unsigned int IO )
{/* function for test if port works ok */
int i,ret=0;
unsigned int rs,ws=0;
char ch[80];

 rs=read_byte(IO+1);/* read current status of port */
 for(i=0;i<=255;i++){/* begin test port */
  sprintf(ch,"\rTesting: |%s", "====================================================");ch[div(i*50,255).quot+11]=0;
  printf("\r%-60s| %3d%% r/w 0x%02X/0x%02X",ch,div(i*100,255).quot,rs,i);
  fflush(NULL);/* progress indicator */
  write_byte(i,IO);/* write to port */
  ws=read_byte(IO);/* read write status of port */
  if(ws!=i) ret=1;/* uh? Port not responding properly. Too slow? */
  ws=read_byte(IO+1);/* read current status of port */
  if(ws!=rs) ret=2;/* uh? Port data changed?!? Possible another interface?*/
  rs=ws;/* remember last signature */
 }/* end for i */
 return(ret);
}/* end test_port() */

int readtest( unsigned int IO )
{/* test reading at device */
int i,j,ret=0;
char tmp[16];

 for(i=1;(i<=16)&&(!ret);i++){/* test each of 16 pins on test socket */
  printf("Connect GND and PIN %d at test socket, press ENTER key to test...",i);
  getchar();portread( IO, tmp );/* read status from device */
  for(j=0;j<=15;j++){ /* test data */
   if((tmp[j]=='0')&&(i!=j+1)){ ret=1;/* found 0 on wrong place, abort */
    printf("Error on pin %d, it's possible that pin %d and pin %d are connected together.\n",j+1,j+1,i);
   }else if((tmp[j]=='1')&&(i==j+1)){ ret=1;/* found 1 on wrong place, abort */
    printf("Error on pin %d, pin not connected to GND ?\n",j+1);
   }/* end else if */
  }/* end for j */
 }/* end for i */
 return(ret);
}/* end readtest() */

int wwritetest( unsigned int IO )
{/* test writing at device */
int i,j,ret=0;
char DATA[17],ch[80];

 for(i=0;(i<=15)&&(!ret);i++){/* test all pins if respond with GND */
  sprintf(DATA,"================");DATA[i]='0';/* set pin to GND */
  sprintf(ch,"\rTesting: |%s", "====================================================");ch[i*3+11]=0;
  printf("\r%-45s| %3d%%",ch,div(i*100,15).quot);fflush(NULL);/* progress bar */
  if(portwrite(IO,DATA)){ret++;/* data select fail */
   printf("\r%79s\rTest fail, setting data on device fail during set %d pin.\n\
 => check ICs from IC2 to IC5, if they connected and working properly\n\
 => check leads on ictester board if they correctly soldered and connected\n\
 => check if all wires on 25pin connector are properly soldered\n"," ",i+1);}
  else {/* setting pass ok, test if data are ok */
   portread(IO,DATA);/* read data */
   for(j=0;j<=15;j++) if(((DATA[j]=='0')&&(j!=i))||((j==i)&&(DATA[j]=='1'))){
    ret++;/* opa, errors */
    if(DATA[i]!='0'){/* ok tested pin fails */
     printf("\r%79s\rTest fail, there are some errors at tested pin %d.\n",
	" ",i+1);
     printf(" => check connections from pin %d at test socket thru transistor ",
i+1);
     switch (i){/* recognize position of transistors */
      case 0:printf("T16 and \nresistor R25 to pin 11 at IC3\n");break;/* 1 */
      case 1:printf("T15 and \nresistor R24 to pin 14 at IC3\n");break;/* 2 */
      case 2:printf("T12 and \nresistor R21 to pin 7 at IC3\n");break;/* 3 */
      case 3:printf("T11 and \nresistor R20 to pin 4 at IC3\n");break;/* 4 */
      case 4:printf("T8 and \nresistor R17 to pin 11 at IC2\n");break;/* 5 */
      case 5:printf("T7 and \nresistor R16 to pin 14 at IC2\n");break;/* 6 */
      case 6:printf("T4 and \nresistor R13 to pin 7 at IC2\n");break;/* 7 */
      case 7:printf("T3 and \nresistor R12 to pin 4 at IC2\n");break;/* 8 */
      case 8:printf("T32 and \nresistor R41 to pin 11 at IC5\n");break;/* 9 */
      case 9:printf("T31 and \nresistor R40 to pin 14 at IC5\n");break;/* 10 */
      case 10:printf("T28 and \nresistor R37 to pin 7 at IC5\n");break;/* 11 */
      case 11:printf("T27 and \nresistor R36 to pin 4 at IC5\n");break;/* 12 */
      case 12:printf("T24 and \nresistor R33 to pin 11 at IC4\n");break;/* 13 */
      case 13:printf("T23 and \nresistor R32 to pin 14 at IC4\n");break;/* 14 */
      case 14:printf("T20 and \nresistor R29 to pin 7 at IC4\n");break;/* 15 */
      case 15:printf("T19 and \nresistor R28 to pin 4 at IC4\n");break;/* 16 */
     }/* end switch */
    }/* end if tested pin */
    if((DATA[j]=='0')&&(j!=i)){/* ok another pin fails */
     printf("\r%79s\rTest fail, there are some errors at pin %d.\n"," ",j+1);
     printf(" => check connections from pin %d at test socket thru transistor ",
j+1);
     switch (j){/* recognize position of transistors */
      case 0:printf("T16 and \nresistor R25 to pin 11 at IC3\n");break;/* 1 */
      case 1:printf("T15 and \nresistor R24 to pin 14 at IC3\n");break;/* 2 */
      case 2:printf("T12 and \nresistor R21 to pin 7 at IC3\n");break;/* 3 */
      case 3:printf("T11 and \nresistor R20 to pin 4 at IC3\n");break;/* 4 */
      case 4:printf("T8 and \nresistor R17 to pin 11 at IC2\n");break;/* 5 */
      case 5:printf("T7 and \nresistor R16 to pin 14 at IC2\n");break;/* 6 */
      case 6:printf("T4 and \nresistor R13 to pin 7 at IC2\n");break;/* 7 */
      case 7:printf("T3 and \nresistor R12 to pin 4 at IC2\n");break;/* 8 */
      case 8:printf("T32 and \nresistor R41 to pin 11 at IC5\n");break;/* 9 */
      case 9:printf("T31 and \nresistor R40 to pin 14 at IC5\n");break;/* 10 */
      case 10:printf("T28 and \nresistor R37 to pin 7 at IC5\n");break;/* 11 */
      case 11:printf("T27 and \nresistor R36 to pin 4 at IC5\n");break;/* 12 */
      case 12:printf("T24 and \nresistor R33 to pin 11 at IC4\n");break;/* 13*/
      case 13:printf("T23 and \nresistor R32 to pin 14 at IC4\n");break;/* 14*/
      case 14:printf("T20 and \nresistor R29 to pin 7 at IC4\n");break;/* 15 */
      case 15:printf("T19 and \nresistor R28 to pin 4 at IC4\n");break;/* 16 */
     }/* end switch */
    }/* end if other pin */
   }/* end if test fail */
   if(ret)
    printf(" => check transistors, if they connected and working properly\n\
 => check resistors, if they connected and working properly to transistors\n\
 => check IC, if it's connected and working properly to resistors\n\
 => check leads on ictester board if they correctly soldered and connected\n");
  }/* end else if portwrite */
 }/* end for i */
 return(ret);
}/* end wwritetest() */

void test( unsigned int  BASEIO )
{/* main test function */
short int tst=1;
char lin[80];

 if (allow_io(BASEIO, 2) == -1) {/* test port access */
  fprintf(stderr,"Mh?! Hmmm... You aren't being allowed access to the ports.\n\
 => Check that you have super user privilege or that program have setuid bit.\n\
 => Check that other program don't use ports from 0x%03X to 0x%03X.\n\
 => Check that ports exists :-), if not chose new with -p flag.\n",
  BASEIO,BASEIO+1);
 }else{ /* all ok do test */
  write_byte(32,BASEIO);/* reset port and disable write */
  printf("Selected port is: 0x%03X.\n\
This test system is designed for testing functionality of ictester device.\n\
Follow instructions, if it's first time that you test ictester device, double\n\
check all connection on it to make sure that you'll not burn you computer.\n\
Especially check power connector on ictester device.\n",BASEIO);
 printf(".---------+--\n| Test 01 | Test port functionality\n+---------'\n|\n");
 printf("\to remove all hardware devices which may disrupt testing port 0x%03X\
\n\to if connected, disconnect ictester from port\n\
\to close or stop all programs that may use port\n",BASEIO);
 printf("\nPress ENTER key to proceed, Q skip...");fgets(lin,80,stdin);
 if(tolower(lin[0])!='q'){/* check if user wants to skip */
  switch (test_port(BASEIO)){/* test port */
   case 1:tst=0;/* uh? Port not responding properly. Too slow? */
	printf("\r%80s\rTesting port 0x%03X failed.\n"," ",BASEIO);
	printf("Can't get response from port, it may be blocked from other device or program.\n");
	break;
   case 2:tst=0;/* uh? Port data changed?!? Possible another interface? */
	printf("\r%80s\rTesting port 0x%03X failed.\n"," ",BASEIO);
	printf("Got answer from port during test phase.\n\
It's possible that some other hardware device respond or some software disrupt\
\ndata transfer.\n"); 
	break;
   default:tst=1;/* test ok */
	printf("\r%80s\rTest past, port 0x%03X works ok.\n"," ",BASEIO);break;
  }/* end switch */
 }else printf("Test skipped...\n");/* user skipped this test */
 write_byte(32,BASEIO);/* reset port and disable write */
 if(tst){/* all ok continue */
  printf(".---------+--\n| Test 02 | Test device connection\n+---------'\n|\n");
  printf("\to DO NOT CONNECT POWER ON ICTESTER DEVICE !!!!\n\
\to connect ictester device to port\n\n\
Press ENTER key to proceed, Q skip...");fgets(lin,80,stdin);
  if(tolower(lin[0])!='q'){/* check if user wants to skip */
   if(is_power_on(BASEIO)) {tst=1;/* check power */
    printf("\r%79s\rTest past, device respond ok.\n"," ");}
   else {tst=0;/* test fail */
	printf("\r%79s\rTest fail, not found device.\n\
 => check if ictester device is connected to port 0x%03X\n\
 => check if all wires on 25pin connector are properly soldered\n\
 => check if all wires on ribbon connector are properly connected\n\
 => check if resistors R4 and R5 are soldered properly\n"," ",BASEIO);
   }/* end else if power */
  }else printf("Test skipped...\n");/* user skipped this test */
 }/* end if test */
 write_byte(32,BASEIO);/* reset port and disable write */
 if(tst){/* all ok continue */
  printf(".---------+--\n| Test 03 | Test device power up\n+---------'\n|\n");
  printf("\to now connect power to ictester device\n\
\to WATCH FOR ORIENTATION WHEN CONNECTING + AND - WIRES !!!\n\n\
Press ENTER key to proceed...");getchar();
  if(is_power_on(BASEIO)){tst=0;/* check power */
   printf("\r%79s\rTest fail, not found respond from device.\n\
 => check if you are properly connected power to ictester device\n\
 => check if any power coming to ictester device\n\
 => check if input power is 6V or up to 9V, possible low input power\n\
 => check that IC6 - 6 volt regulator working properly\n\
 => check if resistors R4 and R5 are soldered and working properly\n"," ");}
  else {tst=1;/* test pass */
   printf("\r%79s\rTest past, device respond ok.\n"," ");
  }/* end else if power */
 }/* end if test */
 if(tst){/* all ok continue */
  printf(".---------+--\n| Test 04 | Test read on device \n+---------'\n|\n");
  printf("\to remove from test socket any IC or other part that may be in it\n\
\to use wire for connecting GND and pins at test socket\nPress ENTER key to\
 proceed, Q skip...\n");fgets(lin,80,stdin);
  if(tolower(lin[0])!='q'){/* check if user wants to skip */
   if(readtest(BASEIO)){ tst=0;/* ups error during read */
    printf("Test fail, reading of device have some errors.\n\
 => if you aren't correctly connect wire with pin on test socket, restart test\
\n => check leads on ictester board which connects IC1 socket and SOC1 if they \
correctly soldered\n\
 => check if is IC1 socket correctly soldered and IC1 correctly connected\n\
 => check if all wires on 25pin connector are properly soldered\n");
   }else{ tst=1;/* all ok continue */
    printf("Test past, device reading ok.\n");
   }/* end else if readtest */
  }else printf("Test skipped...\n");/* user skipped this test */
 }/* end if test */
 if(tst){/* all ok continue */
  printf(".---------+--\n| Test 05 | Test write on device\n+---------'\n|\n");
  printf("\to remove from test socket any IC, wire or other part\n\n\
Press ENTER key to proceed, Q skip...");fgets(lin,80,stdin);
  if(tolower(lin[0])!='q'){/* check if user wants to skip */
   enable_port(1,BASEIO);/* set write enable on ictester device */
   if(wwritetest(BASEIO)) tst=0;/* ups error during write */
   else{ tst=1;/* all ok continue */
    printf("\r%79s\rTest past, device writing ok.\n"," ");
   }/* end else if rwritetest */
   portwrite(BASEIO,"================");/* set to null device */
  }else printf("Test skipped...\n");/* user skipped this test */
 }/* end if test */
 if(tst){/* all ok continue */
  printf(".---------+--\n| Test 06 | Test active write on device\n+---------'\n|\n");
  printf("\to remove from test socket any IC, wire or other part that may be\
 in it\n\to use resistor of 1000 ohm for connecting two pins at test socket\n\
Press ENTER key to proceed, Q skip...\n");fgets(lin,80,stdin);
  if(tolower(lin[0])!='q'){/* check if user wants to skip */
   if(awritetest(BASEIO)) tst=0;/* ups error during active write */
   else{ tst=1;/* all ok continue */
    printf("\r%79s\rTest past, device active writing ok.\n"," ");
   }/* end else if rwritetest */
   portwrite(BASEIO,"================");/* set to null device */
  }else printf("Test skipped...\n");/* user skipped this test */
 }/* end if test */
 if(tst){/* all ok continue */
  printf(".---------+--\n| Test 07 | Test read/write on device\n+---------'\n|\n");
  printf("\to remove from test socket any IC, wire or other part that may be in\
 it\n\nPress ENTER key to proceed, Q skip...");fgets(lin,80,stdin);
  if(tolower(lin[0])!='q'){/* check if user wants to skip */
   if(rwritetest(BASEIO)) tst=0;/* ups error during active write */
   else{ tst=1;/* all ok continue */
    printf("\r%79s\rTest past, device reading/writing ok.\n"," ");
   }/* end else if rwritetest */
   portwrite(BASEIO,"================");/* set to null device */
  }else printf("Test skipped...\n");/* user skipped this test */
 }/* end if test */
 write_byte(32,BASEIO);/* reset port and disable write */
 if(tst){/* all ok continue */
  printf(".---------+--\n| Test OK | Testing completed successfully\n\
+---------'\n|\n");
  printf("\tTesting is complete, you can safely use IC-tester device for\
 testing.\n\
 If you use battery for external power be aware of low power after some time.\n\
 Program will be reporting no power connected if low power occurs, then\n\
 replace battery.\n");
 }else{/* test fail */
  printf(".---------+--\n| Error ! | Testing fail.\n+---------'\n|\n");
  printf("\tTesting fail, there are errors during test, solve problems and\
 run this test again.\n\
 DO NOT USE THIS IC-TESTER DEVICE until all tests pass by ok, if you use it,\n\
 it could damage your computer or testing IC !\n");
 }/* end else if tst */
 if (disallow_io(BASEIO, 2) == -1)/* close port */
  fprintf(stderr, "Woha! Can't disengage port.\n\
You could have some problems with this port from now on...\n");
 }/* end else if port access */
}/* end test() */

void freq_ic(unsigned int IO)
{/* measure working frequency */
int i,j,k,ret,lastpr;
long int start_t,end_t;
char DATA[90];

if (allow_io(IO, 2) == -1) {/* test port access */
 fprintf(stderr,"Opa... You aren't being allowed access to the ports 0x%03X\
 and 0x%03X.\n",IO,IO+1);
}else{ /* all ok do write */
 if(is_power_on(IO)) printf("\nError: ictester device not powered - can not do measure !\n\n");
 else{/* all ok do measure */
  printf("Selected port is: 0x%03X...\n",IO);enable_port(1,IO);/*enable device*/
  printf("Please remove from test socket any IC if it's there.\n\
To continue press enter...");getchar();
  printf("Performing speed measure of setting data to IC Tester device...\n");
  start_t=time(NULL);ret=0;lastpr=-1;/* get start time in seconds */
  /* jeah I know there are better ways, but I don't have time for them now */
  for(i=0;(i<=255)&&(!ret);i++){/* create first 8 pins */
   for(j=0;(j<=255)&&(!ret);j++){/* create last 8 pins */
    for(k=0;k<=15;k++) DATA[k]='1';/* fill with 0 */
    if(i & 1) DATA[0]='0'; if(i & 2) DATA[1]='0'; if(i & 4) DATA[2]='0';
    if(i & 8) DATA[3]='0'; if(i & 16) DATA[4]='0'; if(i & 32) DATA[5]='0';
    if(i & 64) DATA[6]='0'; if(i & 128) DATA[7]='0';/* set first 8 pins */
    if(j & 1) DATA[8]='0'; if(j & 2) DATA[9]='0'; if(j & 4) DATA[10]='0';
    if(j & 8) DATA[11]='0'; if(j & 16) DATA[12]='0'; if(j & 32) DATA[13]='0';
    if(j & 64) DATA[14]='0'; if(j & 128) DATA[15]='0';/* set last 8 pins */
    if(portwrite(IO,DATA)){ret=1;/* data select fail */
     fprintf(stderr,"\r%79s\rMeasure fail, setting data on device fail.\n"," ");
    }/* end if portwrite */
   }/* end for j */
   if(lastpr!=div(i*100,255).quot){/* there is changes, do update */
   sprintf(DATA,"\rMeasuring: |%s", "====================================================");
   DATA[div(i,5).quot+13]=0;lastpr=div(i*100,255).quot;
   printf("\r%-63s| %3d%%",DATA,lastpr);fflush(NULL);}/* progress bar */
  }/* end for i */
  if(!ret){/* ok there's no failure, recalculate frequency */
   end_t=time(NULL);/* get end time in seconds */
   printf("\r%79s\rSetting speed is %ld Hz.\n"," ",
		   ldiv(65536L,end_t-start_t).quot);/* write result */
  }else printf("\r%79s\r"," ");/* end else if ret */
  printf("Performing speed measure of reading data from IC Tester device...\n");
  start_t=time(NULL);ret=0;lastpr=-1;/* get start time in seconds */
  /* jeah I know there are better ways, but I don't have time for them now */
  for(i=0;(i<=255)&&(!ret);i++){/* go thru first 8 pins */
   for(j=0;(j<=255)&&(!ret);j++){/* go thru last 8 pins */
    portread(IO,DATA);DATA[16]=0;/* read data */
    if(strcmp(DATA,"0000000000000000")==-1){ret=1;/* oho, read fail */
     fprintf(stderr,"\r%79s\rMeasure fail, reading data from device fail.\n"," ");
    }/* end if strcmp */
   }/* end for j */
   if(lastpr!=div(i*100,255).quot){/* there is changes, do update */
   sprintf(DATA,"\rMeasuring: |%s", "====================================================");
   DATA[div(i,5).quot+13]=0;lastpr=div(i*100,255).quot;
   printf("\r%-63s| %3d%%",DATA,lastpr);fflush(NULL);}/* progress bar */
  }/* end for i */
  if(!ret){/* ok there's no failure, recalculate frequency */
   end_t=time(NULL);/* get end time in seconds */
   printf("\r%79s\rReading speed is %ld Hz.\n"," ",
		   ldiv(65536L,end_t-start_t).quot);/* write result */
  }else printf("\r%79s\r"," ");/* end else if ret */
  enable_port(0,IO);/* disable IC Tester device */
 }/* end else if power */
 if (disallow_io(IO, 2) == -1)/* close port */
  fprintf(stderr, "Woha! Can't disengage port.\n\
You culd have some problems with this port from now on...\n");
}/* end else if port access */
}/* end freq_ic() */

