/*****************************************************************************
 *  test_ocr.c: here are functions for testing OCR add-on on ictester device
 *  This is part of IC-tester program.
 *  Copyright (C) 2001,2002  Silvio Klaic, sklaic@student.math.hr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *****************************************************************************/
#ifndef DOS
#include <unistd.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "portlib.h"
#include "device.h"

void test_ocr( unsigned int  BASEIO )
{/* main test function */
short int tst=1;
char lin[80];

if (allow_io(BASEIO, 2) == -1) {/* test port access */
 fprintf(stderr,"Mh?! Hmmm... You aren't being allowed access to the ports.\n\
 => Check that you have super user privilege or that program have setuid bit.\n\
 => Check that other program don't use ports from 0x%03X to 0x%03X.\n\
 => Check that ports exists :-), if not chose new with -p flag.\n",
  BASEIO,BASEIO+1);
}else{ /* all ok do test */
 write_byte(32,BASEIO);/* reset port and disable write */
 printf("Selected port is: 0x%03X.\n\
This test system is designed for testing functionality of OCR/Diode add-on at\n\
ictester device. Follow instructions and make repairs if necessary.\n\n",BASEIO);
 printf(".------------+--\n| Quick test | Perform quick test on IC-Tester\
 device\n+------------'\n|\n\to Remove from test socket any IC, addon or\
 other part that may be in it\n\nPress ENTER key to proceed, Q quit...");
 fgets(lin,80,stdin);/* get user respond */
 if(tolower(lin[0])!='q'){/* check if user wants to quit */
  if(is_power_on(BASEIO)){tst=0;/* check power */
   printf("Test fail, not found respond from device.\n\
 => check if you are properly connected power to ictester device\n\
 => check if any power coming to ictester device\n\
 => check if input power is 6V or up to 12V, possible low battery?\n\
 => do full test on IC-Tester device with -t option\n");
  }else tst=1;/* end else if power */
  enable_port(1,BASEIO);/* enable ictester device */
  if(tst){/* all ok continue */
   portwrite(BASEIO,"0=0=0=0=0=0=0=0=");portread(BASEIO,lin);lin[16]=0;tst=0;
   if(strcmp(lin,"0101010101010101")!=0){/* oh, data on IC tester? */
    printf("ERROR: got data from test socket at ictester device and there\
 shouldn't be any!\n\
 => check that nothing is on test socked and run test again\n\
 => do full test on IC-Tester device with -t option\n");
   }else tst=1;/* end else if readtest */
  }/* end if test */
  if(tst){/* all ok continue */
   portwrite(BASEIO,"=0=0=0=0=0=0=0=0");portread(BASEIO,lin);lin[16]=0;
   if(strcmp(lin,"1010101010101010")!=0){/* oh, data on IC tester? */
    printf("Test fail, got data from test socket at device and there shouldn't\
 be any!\n\
 => check leads on ictester board which connects IC1 socket and SOC1 if they \
are correctly soldered\n\
 => check if is IC1 socket correctly soldered and IC1 correctly connected\n\
 => check if all wires on 25pin connector are properly soldered\n");
   }else tst=1;/* end else if readtest */
  }/* end if test */
  write_byte(32,BASEIO);/* reset port and disable write */
  if(tst) printf("Test past, IC-Tester device respond ok.\n");
 }else{tst=-1; printf("Test aborted...\n");}/* user aborted this test */
 if(tst>0){/* all ok continue */
  printf(".-------------+--\n| Add-on test | Make full test on OCR/Diode add-on\
\n+-------------'\n|\n\to Connect OCR/Diode add-on on test socket\n\to Remove\
 from add-on test socket any component that may be in it\n\nPress ENTER key to\
 proceed, Q skip...");fgets(lin,80,stdin);
  if(tolower(lin[0])!='q'){/* check if user wants to skip */
   enable_port(1,BASEIO);/* set write enable on ictester device */
   tst=0;portwrite(BASEIO,"0===============");portread(BASEIO,lin);lin[16]=0;
   if(strcmp(lin,"0111111111111111")!=0){/* oh, got signal thru transistor */
    printf("Test fail, got data on other pins.\n");
    if(lin[1]=='0') /* contact with pin 2 */
     printf(" => check copper lines on pins 1 and 2 and at end of R3 and R2\
 possible contact\n");
    if(lin[2]=='0') /* contact with pin 3 */
     printf(" => check copper lines on end of R3 and pin 3 possible contact\n");
    if(lin[3]=='0')/* contact with pin 4 */
     printf(" => check copper lines on end of R3 and pin 4 possible contact\n");
    if((lin[4]=='0')||(lin[5]=='0'))/* contact with pin 5-6 or transistor */
     printf(" => check copper lines on end of R3 and pins 5 and 6 possible\
 contact\n => check if transistor T3 working correctly, it may burn out.\n");
   }else tst=1;/* test past ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"=0==============");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1011111111111111")!=0){/* oh, got signal thru transistor */
    printf("Test fail, got data on other pins.\n");
    if(lin[2]=='0') /* contact with pin 3 */
     printf(" => check copper lines on pins 2 and 3 and at end of R2 and R1\
 possible contact\n");
    if((lin[4]=='0')||(lin[5]=='0')||(lin[9]=='0')||(lin[10]=='0'))/* 10 & 11 */
     printf(" => check copper lines on end of R2 and pins 5, 6, 10 and 11\
 possible contact\n");
    if((lin[6]=='0')||(lin[8]=='0'))/* contact with pin 7-9 or transistor */
     printf(" => check copper lines on end of R2 and pins 7 and 9 possible\
 contact\n => check if transistor T2 working correctly, it may burn out.\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"==0=============");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1101111111111111")!=0){/* oh, got signal thru transistor */
    printf("Test fail, got data on other pins.\n");
    if((lin[15]=='0')||(lin[14]=='0')||(lin[13]=='0')||(lin[12]=='0'))/*16-13*/
     printf(" => check copper lines on end of R1 and pins 13, 14, 15 and 16\
 possible contact\n");
    if((lin[10]=='0')||(lin[11]=='0'))/* contact with pin 11-12 or transistor */
     printf(" => check copper lines on end of R1 and pins 11 and 12 possible\
 contact\n => check if transistor T1 working correctly, it may burn out.\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"====0===========");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"0111011111111111")!=0){/* transistor not working? */
    printf("Test fail, transistor T3 not respond correctly.\n => check if\
 resistor R3 working correctly, it may be burn out\n");
    if(lin[4]=='1')/* no signal from transistor */
     printf(" => check if transistor T3 working correctly, it may burn out or\
 it's misplaced\n");
    if(lin[5]=='0')/* signal from other side of transistor */
     printf(" => check if transistor T3 working correctly, it may be melted\
 (short circuit)\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"=====0==========");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"0111101111111111")!=0){/* transistor not working? */
    printf("Test fail, transistor T3 not respond correctly.\n => check if\
 resistor R3 working correctly, it may be burn out\n");
    if(lin[4]=='0')/* signal from other side of transistor */
     printf(" => check if transistor T3 working correctly, it may be melted\
 (short circuit)\n");
    if(lin[5]=='1')/* no signal from transistor */
     printf(" => check if transistor T3 working correctly, it may burn out or\
 it's misplaced\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"======0=========");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1011110111111111")!=0){/* transistor not working? */
    printf("Test fail, transistor T2 not respond correctly.\n => check if\
 resistor R2 working correctly, it may be burn out\n");
    if(lin[6]=='1')/* no signal from transistor */
     printf(" => check if transistor T2 working correctly, it may burn out or\
 it's misplaced\n");
    if(lin[9]=='0')/* signal from other side of transistor */
     printf(" => check if transistor T2 working correctly, it may be melted\
 (short circuit)\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"=========0======");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1011111110111111")!=0){/* transistor not working? */
    printf("Test fail, transistor T2 not respond correctly.\n => check if\
 resistor R2 working correctly, it may be burn out\n");
    if(lin[6]=='0')/* signal from other side of transistor */
     printf(" => check if transistor T2 working correctly, it may be melted\
 (short circuit)\n");
    if(lin[9]=='1')/* no signal from transistor */
     printf(" => check if transistor T2 working correctly, it may burn out or\
 it's misplaced\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"==========0=====");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1101111111011111")!=0){/* transistor not working? */
    printf("Test fail, transistor T1 not respond correctly.\n => check if\
 resistor R1 working correctly, it may be burn out\n");
    if(lin[10]=='1')/* no signal from transistor */
     printf(" => check if transistor T1 working correctly, it may burn out or\
 it's misplaced\n");
    if(lin[11]=='0')/* signal from other side of transistor */
     printf(" => check if transistor T1 working correctly, it may be melted\
 (short circuit)\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"===========0====");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1101111111101111")!=0){/* transistor not working? */
    printf("Test fail, transistor T1 not respond correctly.\n => check if\
 resistor R1 working correctly, it may be burn out\n");
    if(lin[10]=='0')/* signal from other side of transistor */
     printf(" => check if transistor T1 working correctly, it may be melted\
 (short circuit)\n");
    if(lin[11]=='1')/* no signal from transistor */
     printf(" => check if transistor T1 working correctly, it may burn out or\
 it's misplaced\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   /* Ok so far so good, now we must test how it react on +5V signal */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"1===0===========");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1111001111111111")!=0){/* transistor not working? */
    printf("Test fail, transistor T3 not respond correctly.\n");
    if((lin[4]=='0')&&(lin[5]=='1'))/* no signal on transistor */
     printf(" => check if resistor R3 working correctly, it may be burn out\n\
 => check if transistor T3 working correctly, it may be burn out\n");
    else/* possible signal to other pins */ 
     printf(" => check if copper lines to transistor T3 are not in contact with\
 some others\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"=1====0=========");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1111110110111111")!=0){/* transistor not working? */
    printf("Test fail, transistor T2 not respond correctly.\n");
    if((lin[6]=='0')&&(lin[9]=='1'))/* no signal on transistor */
     printf(" => check if resistor R2 working correctly, it may be burn out\n\
 => check if transistor T2 working correctly, it may be burn out\n");
    else/* possible signal to other pins */ 
     printf(" => check if copper lines to transistor T2 are not in contact with\
 some others\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   if(tst){/* all ok continue */
    tst=0;portwrite(BASEIO,"==1=======0=====");portread(BASEIO,lin);lin[16]=0;
    if(strcmp(lin,"1111111111001111")!=0){/* transistor not working? */
    printf("Test fail, transistor T1 not respond correctly.\n");
    if((lin[10]=='0')&&(lin[11]=='1'))/* no signal on transistor */
     printf(" => check if resistor R1 working correctly, it may be burn out\n\
 => check if transistor T1 working correctly, it may be burn out\n");
    else/* possible signal to other pins */ 
     printf(" => check if copper lines to transistor T1 are not in contact with\
 some others\n");
    }else tst=1;/* test past ok */
   }/* end if all ok */
   portwrite(BASEIO,"================");/* set to null device */
   if(tst) printf("Test past, OCR/Diode add-on device respond ok.\n");
  }else{ tst=-1; printf("Test skipped...\n");}/* user skipped this test */
 }/* end if test */
 write_byte(32,BASEIO);/* reset port and disable write */
 if(tst>0){/* all ok continue */
  printf(".---------+--\n| Test OK | Testing completed successfully\n\
+---------'\n|\n");
  printf("\tTesting is complete, you can safely use OCR/Diode add-on on\
 IC-Tester\n device for testing.\n");
 }else if(tst!=-1){/* test fail */
  printf(".---------+--\n| Error ! | Testing fail.\n+---------'\n|\n");
  printf("\tTesting fail, there are errors during test, solve problems and\n\
 run this test again.\n DO NOT USE THIS ADD-ON AT IC-TESTER DEVICE until all\
 tests pass by ok.\n");
 }/* end else if tst */
 if (disallow_io(BASEIO, 2) == -1)/* close port */
  fprintf(stderr, "Woha! Can't disengage port.\n\
You could have some problems with this port from now on...\n");
}/* end else if port access */
}/* end test_ocr() */
